/*
 *    **************************************************
 *    *                                                *
 *    *                   KALEIDS.C                    *
 *    *                                                *
 *    *              EGA/VGA Kaleidoscope              *
 *    *                                                *
 *    *              Version 3.5 11-09-88              *
 *    *                                                *
 *    *              Judson D. McClendon               *
 *    *              329 37th Court N.E.               *
 *    *              Birmingham, AL 35215              *
 *    *                 205-853-8440                   *
 *    *            Compuserve [74415,1003]             *
 *    *                                                *
 *    **************************************************
 */


/*
 *    **************************************************
 *    *                                                *
 *    *                    Includes                    *
 *    *                                                *
 *    **************************************************
 */


#include <conio.h>
#include <ctype.h>
#include <dos.h>
#include <graphics.h>
#include <stdlib.h>
#include <stdio.h>
#include <sys\timeb.h>




/*
 *    **************************************************
 *    *                                                *
 *    *              Function Declarations             *
 *    *                                                *
 *    **************************************************
 */

void main(int argc,char *argv[]);
void Initialize(void);

int  GetChar(void);
int  KeyPressed(void);

void ScrClr(void);
void WriteAt(int row,int col,char *str);

static long TimerTicks(void);




/*
 *    **************************************************
 *    *                                                *
 *    *                    Defines                     *
 *    *                                                *
 *    **************************************************
 */

#define TRUE         1
#define FALSE        0
#define ESC          27
#define SFACTOR      1000
#define COLORSCREEN  0xB8000000L  /* Color buffer address */




/*
 *    **************************************************
 *    *                                                *
 *    *                  Data Types                    *
 *    *                                                *
 *    **************************************************
 */

typedef struct {                 /* Screen char struct */
   char
      data,
      attr;
   } CHTYPE;

typedef struct {                 /* Screen memory structure */
   CHTYPE ch[25][80];
   } far *SCREENTYPE;




/*
 *    **************************************************
 *    *                                                *
 *    *                Global Variables                *
 *    *                                                *
 *    **************************************************
 */

int X1, Y1, X2, Y2, XV1, YV1, XV2, YV2, HC, XA, YA, XB, YB, chr;
int i, bc = 1, dely = 0, skipopen = FALSE;
int wid = 4, hgt = 3;
int CX = 320, CY = 240, M = 240;

int Red[MAXCOLORS+1], Green[MAXCOLORS+1], Blue[MAXCOLORS+1];
long dummy = 0;

SCREENTYPE                       /* Screen pointer  */
   scr;

int
   arow = 0,                     /* Absolute row    */
   acol = 0;                     /* Absolute column */

union REGS
   cpu;                          /* CPU registers for int86() */




/*
 *    **************************************************
 *    *                                                *
 *    *                     Main                       *
 *    *                                                *
 *    **************************************************
 */

void main(int argc,char *argv[])
{

   for (i = 1; i < argc; i++) {
      chr = *argv[i];
      if (chr < 128)
         if (isdigit(chr)) {
            dely = ('9' - chr) * SFACTOR;
            skipopen = TRUE;
            }
         else if (toupper(*argv[i]) == 'B') {
            bc = 0;
            skipopen = TRUE;
            }
      }

   Initialize();

   while (TRUE) {
      cleardevice();

      if (bc)
         setrgbpalette(0, 0, 0, 0);
      for (i = bc; i <= MAXCOLORS; i++) {
         Red[i] = random(64);
         Green[i] = random(64);
         Blue[i] = random(64);
         setrgbpalette(i, Red[i], Green[i], Blue[i]);
         }

      X1 = random(M) + 1;
      X2 = random(M) + 1;
      Y1 = random(X1);
      Y2 = random(X2);

      while (random(130) > 1) {
         XV1 = random(5) - 2;
         XV2 = random(5) - 2;
         YV1 = random(5) - 2;
         YV2 = random(5) - 2;
         HC = random(16);
         setcolor(HC);

         while (random(30) > 1) {
            XA = X1 * wid / hgt;
            XB = X2 * wid / hgt;
            YA = Y1 * wid / hgt;
            YB = Y2 * wid / hgt;
            line( (CX+XA), (CY-Y1), (CX+XB), (CY-Y2) );
            line( (CX-YA), (CY+X1), (CX-YB), (CY+X2) );
            line( (CX-XA), (CY-Y1), (CX-XB), (CY-Y2) );
            line( (CX-YA), (CY-X1), (CX-YB), (CY-X2) );
            line( (CX-XA), (CY+Y1), (CX-XB), (CY+Y2) );
            line( (CX+YA), (CY-X1), (CX+YB), (CY-X2) );
            line( (CX+XA), (CY+Y1), (CX+XB), (CY+Y2) );
            line( (CX+YA), (CY+X1), (CX+YB), (CY+X2) );
            X1 = (X1 + XV1) % M;
            Y1 = (Y1 + YV1) % M;
            X2 = (X2 + XV2) % M;
            Y2 = (Y2 + YV2) % M;
            if (dely) {
               for (i = 1; i < dely; i++) {
                  dummy += i * dely;
                  dummy -= dely;
                  }
               }
            }

         if (chr = KeyPressed()) {
            if (chr == 'P') {
               GetChar();
               }
            else if (chr == ESC) {
               cleardevice();
               closegraph();
               exit(0);
               }
            else if (chr == 'C') {
               break;
               }
            else if (chr == 'B') {
               bc = 1 - bc;
               break;
               }
            else if (isdigit(chr)) {
               dely = ('9' - chr) * SFACTOR;
               }
            }

         }  /* while (line) */

      }  /* while (screen) */

   closegraph();
   exit(0);

}




/*
 *    **************************************************
 *    *                                                *
 *    *                  Initialize                    *
 *    *                                                *
 *    **************************************************
 */

void Initialize()
{

   long endtime, waittime;
   int GraphDriver, GraphMode;

   cpu.h.ah = 15;                   /* Get current video mode */
   int86(16, &cpu, &cpu);
   if (cpu.h.al != 3) {             /* 80x25 color */
      puts("Display must be 80x25 color");
      exit(1);
      }
   scr = (SCREENTYPE)((void far *)COLORSCREEN); /* Screen memory pointer */

   randomize();                     /* Randomize random number generator */

   if (! skipopen) {
      ScrClr();

      WriteAt( 1, 2, "KaleidsKaleidsKaleidsKaleidsKaleidsKaleidsKaleidsKaleidsKaleidsKaleidsKaleids");
      WriteAt( 2, 2, "KaleidsKaleidsKaleidsKaleidsKaleidsKaleidsKaleidsKaleidsKaleidsKaleidsKaleids");
      WriteAt( 3, 2, "KaleidsKaleidsKaleidsKaleidsKaleidsKaleidsKaleidsKaleidsKaleidsKaleidsKaleids");
      WriteAt( 4, 2, "KaleidsKaleidsKaleidsKalĿidsKaleidsKaleidsKaleids");
      WriteAt( 5, 2, "KaleidsKaleidsKaleidsKal  K A L E I D O S C O P E  idsKaleidsKaleidsKaleids");
      WriteAt( 6, 2, "KaleidsKaleidsKaleidsKal                           idsKaleidsKaleidsKaleids");
      WriteAt( 7, 2, "KaleidsKaleidsKaleidsKal  Version 3.5 for EGA/VGA  idsKaleidsKaleidsKaleids");
      WriteAt( 8, 2, "KaleidsKaleidsKaleidsKal                           idsKaleidsKaleidsKaleids");
      WriteAt( 9, 2, "KaleidsKaleidsKaleidsKal    Judson D. McClendon    idsKaleidsKaleidsKaleids");
      WriteAt(10, 2, "KaleidsKaleidsKaleidsKal    329 37th Court N.E.    idsKaleidsKaleidsKaleids");
      WriteAt(11, 2, "KaleidsKaleidsKaleidsKal    Birmingham, AL 35215   idsKaleidsKaleidsKaleids");
      WriteAt(12, 2, "KaleidsKaleidsKaleidsKal       205-853-8440        idsKaleidsKaleidsKaleids");
      WriteAt(13, 2, "KaleidsKaleidsKaleidsKal  Compuserve [74415,1003]  idsKaleidsKaleidsKaleids");
      WriteAt(14, 2, "KaleidsKaleidsKaleidsKal                           idsKaleidsKaleidsKaleids");
      WriteAt(15, 2, "KaleidsKaleidsKaleidsKal  Press: to:               idsKaleidsKaleidsKaleids");
      WriteAt(16, 2, "KaleidsKaleidsKaleidsKal     'P' pause             idsKaleidsKaleidsKaleids");
      WriteAt(17, 2, "KaleidsKaleidsKaleidsKal     'C' clear screen      idsKaleidsKaleidsKaleids");
      WriteAt(18, 2, "KaleidsKaleidsKaleidsKal     'B' toggle background idsKaleidsKaleidsKaleids");
      WriteAt(19, 2, "KaleidsKaleidsKaleidsKal '0'-'9' set speed         idsKaleidsKaleidsKaleids");
      WriteAt(20, 2, "KaleidsKaleidsKaleidsKal  ESCape exit              idsKaleidsKaleidsKaleids");
      WriteAt(21, 2, "KaleidsKaleidsKaleidsKal any key begin/resume...   idsKaleidsKaleidsKaleids");
      WriteAt(22, 2, "KaleidsKaleidsKaleidsKalidsKaleidsKaleidsKaleids");
      WriteAt(23, 2, "KaleidsKaleidsKaleidsKaleidsKaleidsKaleidsKaleidsKaleidsKaleidsKaleidsKaleids");
      WriteAt(24, 2, "KaleidsKaleidsKaleidsKaleidsKaleidsKaleidsKaleidsKaleidsKaleidsKaleidsKaleids");
      WriteAt(25, 2, "KaleidsKaleidsKaleidsKaleidsKaleidsKaleidsKaleidsKaleidsKaleidsKaleidsKaleids");

      arow = 0;                        /* Move cursor to 0,0 */
      acol = 0;
      cpu.h.ah = 2;
      cpu.h.bh = 0;
      cpu.h.dh = arow;
      cpu.h.dl = acol;
      int86(16, &cpu, &cpu);
      scr->ch[arow][acol].attr = 0;    /* Set cursor color to black on black */

      endtime = TimerTicks() + 162;    /* Show title screen about 10 seconds */

      do {                                /* Kaleidoscope title */

         waittime = TimerTicks() + 1;      /* Will delay for one clock tick */

         for (arow = 0; arow < 25; arow++)
            for (acol = 1; acol < 78; acol++)
               if (arow < 5 || arow > 20 || acol < 26 || acol > 52)
                  if (!(--scr->ch[arow][acol].attr))
                     scr->ch[arow][acol].attr = 15;

         while (TimerTicks() < waittime)   /* Delay */
            ;
         } while ((! (chr = KeyPressed())) && TimerTicks() < endtime);

      ScrClr();

      if (chr == ESC) {
         exit(0);
         }

      } /* if (! skipopen) */

   registerbgidriver(EGAVGA_driver);
   GraphDriver = VGA;
   GraphMode = VGAHI;
   initgraph(&GraphDriver, &GraphMode, "");     /* Try VGA 640x480x16 color */
   if (graphresult()) {
      CY = 175;
      wid = 9;
      hgt = 5;
      GraphDriver = EGA;
      GraphMode = EGAHI;
      initgraph(&GraphDriver, &GraphMode, "");  /* Try EGA 640x350x16 color */
      if (graphresult()) {
         puts("Display must be EGA or VGA");
         closegraph();
         exit(1);
         }
      }
   M = CY - 1;

}




/*
 *    **************************************************
 *    *                                                *
 *    *              Keyboard Routines                 *
 *    *                                                *
 *    **************************************************
 */


/*
 *    **************************************************
 *    *                                                *
 *    *         Get decoded character from kbd         *
 *    *                                                *
 *    **************************************************
 */

int GetChar(void)

{

   int chr;

   chr = getch();
   if (chr == 0)
      chr = 1000 + getch();      /* Non ASCII character */
   else
      if (isascii(chr) )
         chr = toupper(chr);

   return(chr);

}




/*
 *    **************************************************
 *    *                                                *
 *    *         Return character if key pressed        *
 *    *                                                *
 *    **************************************************
 */

int KeyPressed(void)

{

   if (kbhit())
      return(GetChar());
   else
      return(0);

}




/*
 *    **************************************************
 *    *                                                *
 *    *                Screen Routines                 *
 *    *                                                *
 *    **************************************************
 */


/*
 *    **************************************************
 *    *                                                *
 *    *                Clear the Screen                *
 *    *                                                *
 *    **************************************************
 */

void ScrClr(void)

{

   CHTYPE byte, far *pos, far *pend;

   pos = &scr->ch[0][0];
   pend = pos + 2000;
   byte.data = ' ';
   byte.attr = 7;

   while (pos < pend)
      *pos++ = byte;

}




/*
 *    **************************************************
 *    *                                                *
 *    *       Write String at row, col to Screen       *
 *    *                                                *
 *    **************************************************
 */

void WriteAt(int row, int col, char *str)

{

   int i, n, x, y, color, lst;

   arow = row - 1;
   acol = col - 1;

   while (*str) {

      if (arow > 4 && arow < 21 && acol > 25 && acol < 53) {
         color = 15;
         }
      else {
         x = abs(39 - acol);
         y = abs(12 - arow);
         n = x*x + y*y;
         lst = n >> 1;
         for (i = 1; i < 5; i++) {
            if (! lst) {
               color = 0;
               break;
               }
            color = (n / lst + lst) >> 1;
            lst = color;
            }
         color = (color % 15) + 1;
         }

      scr->ch[arow][acol].data = *(str++);
      scr->ch[arow][acol].attr = (char)color;
      if (++acol > 79) {
         arow++;
         acol = 0;
         }
      }

}




/*
 *    **************************************************
 *    *                                                *
 *    *            Miscellaneous Routines              *
 *    *                                                *
 *    **************************************************
 */


/*
 *    **************************************************
 *    *                                                *
 *    *         Fetch Timer Ticks since Midnight       *
 *    *                                                *
 *    **************************************************
 */

static long TimerTicks(void)
{

   static long ticks;

   cpu.h.ah = 0;
   int86(0x1A, &cpu, &cpu);

   ticks = (((long) cpu.x.cx) << 16) + ((long) cpu.x.dx);
   return(ticks);

}
